/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
*
*  MODULE :             Linked Element
*  SCOPE :              Implements list of linked elements
*  FILE :               linkedlist.cc
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

/* IMPORTS *******************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif


#ifndef _linkedlist_HXX
#include "linkedlist.hxx"
#endif

/*= EXTERNAL FUNCTION =======================================================*/
LinkedList::LinkedList()
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  _firstBumper._prev = NULL ;
  _firstBumper._next = &_lastBumper ;
  _lastBumper._prev =  &_firstBumper ;
  _lastBumper._next = NULL ;  
}


/*= EXTERNAL FUNCTION =======================================================*/
void LinkedList::insertHead(LinkedElem* el)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  el->_prev = &_firstBumper ;
  el->_next = _firstBumper._next ;
  _firstBumper._next->_prev = el ;
  _firstBumper._next = el ;
}


/*= EXTERNAL FUNCTION =======================================================*/
void LinkedList::insertTail(LinkedElem* el)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  el->_next = &_lastBumper ;
  el->_prev = _lastBumper._prev ;
  _lastBumper._prev->_next = el ;
  _lastBumper._prev = el ;
}
 
